<script lang="ts">
import { computed, ComputedRef, defineComponent, reactive, ref } from '@vue/composition-api'
import { getConnection } from '@/plugins/connect'
import { Msg, StringCodec } from "nats.ws"
import strftime from 'strftime';
import { EPNMessage, workstations } from '@/model';
import { httpGet, httpPost } from "@/utils/connection";
import ChipCounter from '@/components/ChipCounter.vue';
import { useState } from 'vuex-composition-helpers';
import _ from 'lodash'
import OrderSummary from './OrderSummary.vue';

interface Message {
	subject: string,
	msg: EPNMessage,
	timestamp: Date
}

export default defineComponent({
	name: "MessageLog",
	components: {
		ChipCounter, OrderSummary
	},
	props: {
		value: {
			type: Number,
			default: 0,
		},
		showDispatchToggle:{
			type: Boolean,
			default: false
		}
	},
	setup(props, { root }) {
		var msglist = ref([] as Msg[]);
		var times = ref([] as Date[]);
		var previousMessages = ref([] as Message[]);
		const clock = (date: Date) => strftime("%H:%M:%S", date);
		const host = process.env.VUE_APP_API_URL ?? "";

		httpGet(`${host}/nats/messagelog`).then((res) => {
			previousMessages.value = res?.messages.map(
				({ subject, code, payload, timestamp }: { subject: string, code: number, payload: Object, timestamp: string }) => (
					{ subject, code, msg: { code, payload }, timestamp: new Date(timestamp) }));
			// previousMessages.value = previousMessages.value.sort((a,b) => a.timestamp.getTime() - b.timestamp.getTime() )
			// console.log(previousMessages)
		})

		var sc = StringCodec();
		var messages: ComputedRef<Message[]> = computed(() =>
			_.concat(msglist.value.map((item, i) =>
				({ subject: item.subject, msg: JSON.parse(sc.decode(item.data as Uint8Array)), timestamp: times.value[i] as Date })),
				previousMessages.value as Message[]));

		getConnection().then(async (nc) => {
			if (nc) {
				var sub = nc.subscribe(">");
				for await (const msg of sub) {
					// console.log(msg)
					times.value.unshift(new Date());
					msglist.value.unshift(msg);
				}
			} else {
				console.log("Could not connect to NATS server");
			}
		}
		);

		function clear() {
			previousMessages.value = [];
			msglist.value = [];
		}

		function getLabel(code: Number) {
			return Object.values(workstations).flatMap(w => w.codetable).find(c => c.code == code)?.label;
		}

		var dispatchDialog = ref(false);
		var dispatchServer = process.env.VUE_APP_API_URL ?? "";
		var dispatchState = ref(false);

		(async () => {
			if(props.showDispatchToggle){
				
				let data = await httpGet(`${dispatchServer}/nats/active`);
			// console.log(data);
			dispatchState.value = data?.dispatchEnabled;
			}
		})();

		async function toggleDispatch() {
			dispatchState.value = !dispatchState.value;
			let data = await httpPost(`${dispatchServer}/nats/active`, { enabled: dispatchState.value });
		}

		return { messages, msglist, times, clock, clear, getLabel, dispatchDialog, dispatchServer, dispatchState, toggleDispatch };
	},
})
</script>

<template>
	<div class="wrapper">
		<div class="header">
			<div class="text-button">
				<v-icon>mdi-message-text</v-icon>
				Message log
			</div>
			<v-spacer></v-spacer>

			<v-tooltip left color="secondary" v-if="showDispatchToggle">
				<template v-slot:activator="{on, attrs}">
					<div v-on="on" v-bind="attrs">
						<v-switch inset dense class="pa-0 ma-0" @click="toggleDispatch" :value="dispatchState" hide-details prepend-icon="mdi-server">
						</v-switch>
					</div>
				</template>
				<div class="text-center">NATS responses are {{ dispatchState ? "enabled" : "disabled" }} <br> ({{ dispatchServer }})</div>
			</v-tooltip>

			<v-tooltip left color="secondary">
				<template v-slot:activator="{on, attrs}">
					<v-btn @click="clear" fab plain x-small v-on="on" v-bind="attrs">
						<v-icon>mdi-cancel</v-icon>
					</v-btn>
				</template>
				<span>Clear</span>
			</v-tooltip>
		</div>
		<v-divider></v-divider>

		<transition-group name="list" tag="div" class="msgs" mode="in-out">
			<div v-for="({subject, timestamp, msg : {code, payload}}, i) in messages" :key="(messages.length - i) + timestamp + code" class="message">
				<div class="message-content">
					<div class="message-code text-h6">{{code}}</div>
					<div class="clock">{{clock(timestamp)}}</div>
					<div class="overline message-subject">
						{{subject}}
					</div>
					<div class="subtitle message-label">
						{{getLabel(code)}}
						<template v-if="payload && (payload.color || payload.rfid)">
							:
							<chip-counter v-if="payload.color" :color="payload.color"></chip-counter>
							<kbd class="ml-2" v-if="payload.rfid">#{{payload.rfid}}</kbd>
						</template>
					</div>

					<div v-if="payload" class="message-payload-extended font-italic">

						<template v-if="payload.ordered === true">
							<v-icon color="success">mdi-check-bold</v-icon>
							This chip can be assigned to an order.
						</template>
						<template v-if="payload.ordered === false">
							<v-icon color="error">mdi-close-thick</v-icon>
							This chip cannot be assigned to an order and should be discarded.
						</template>

						<template v-if="payload.passed === true">
							<v-icon color="success">mdi-check-bold</v-icon>
							This chip passed all quality control tests.
						</template>
						<template v-if="payload.passed === false">
							<v-icon color="error">mdi-close-thick</v-icon>
							This chip was discarded.
						</template>

						<template v-if="payload.reason">
							Reason: {{payload.reason}}
						</template>

						<template v-if="payload.orderid">
							Order ID: #{{payload.orderid}}
						</template>

						<template v-if="payload.id">
							Order queued: 
							<order-summary :order="payload"></order-summary>
						</template>

						<div class="d-flex align-center pa-0 ma-0" v-if="Array.isArray(payload.items)">
							<chip-counter size="2em" class="pl-0 ml-0 pr-2" showCounter v-for="chip in payload.items.filter(x => x.amount != 0)" :key="chip.color" v-bind="chip"></chip-counter>
						</div>
					</div>
				</div>
				<div class="divider">
					<v-divider></v-divider>
				</div>
			</div>
		</transition-group>
	</div>
</template>

<style scoped>
.header {
	display: flex;
	align-items: center;
	white-space: nowrap;
	padding: 0.5em 1em;
}

.server {
	display: flex;
	align-items: center;
}

.list-enter-active,
.list-leave-active {
	transition: all 0.5s;
}
.list-enter,
.list-leave-to {
	opacity: 0;
}
.list-move {
	transition: transform 0.5s;
}
.clock {
	font-style: italic;
	grid-area: clock;
}
.message-subject {
	grid-area: subject;
}
.message-code {
	text-align: center;
	grid-area: code;
}
.message-label {
	grid-area: label;
	display: flex;
	align-items: center;
}
.message-payload-extended {
	grid-area: payload;
	display: flex;
	gap: 10px;
	align-items: center;
}
.divider {
	grid-area: divider;
}
.message-content {
	display: grid;
	align-items: center;
	grid-template-columns: 7em 1fr;
	grid-template-areas:
		"code subject clock"
		"code label short"
		"code payload payload"
		"divider divider divider";
	padding: 0.7em;
	padding-left: 0;
}
.wrapper {
	height: 100%;
	display: flex;
	flex-flow: column;
	overflow: hidden;
	min-width: 480px;
}
.msgs {
	/* display: flex; */
	/* flex-direction: column-reverse;
	align-items: flex-end; */
	overflow-y: auto;
	overflow-x: hidden;
	flex-grow: 1;
}
</style>